UNIT mTAmpel5; { mk, 7.5.03, mit Counter, ohne "inneres" Ereignis}

interface

type
   TZustand = (rot,rotgelb,dauergruen,gruen,gelb);
   TEingabe = (OCN,Taste);

   TEreignis = procedure of object;

   TAmpel = CLASS

     // Attribute
     private
        FZustand : TZustand;
        FCounter : word;
     public
       OnChangeZustand : TEreignis;
     // Methoden
     public
        procedure SetZustand(z : TZustand);
        procedure switchZustand(eingabe : TEingabe);
        function GetZustand : TZustand;
        constructor Create;
        procedure SetCounter(t : word);
        function GetCounter : word;
        procedure DecCounter;
   end;

implementation

//+---------------------------------------------------------------------
//|         TAmpel: Methodendefinition
//+---------------------------------------------------------------------

constructor TAmpel.Create;
begin
  inherited Create;
  FZustand := dauergruen; FCounter := 0;
  if Assigned(OnChangeZustand) then OnChangeZustand;
end;

//-------- SetZustand (public) -----------------------------------------
procedure TAmpel.SetZustand(z : TZustand);
begin
  FZustand := z;
  if Assigned(OnChangeZustand) then OnChangeZustand;
end;

//-------- switchZustand (public) --------------------------------------
procedure TAmpel.switchZustand(eingabe : TEingabe);
begin
  if eingabe = OCN
  then
    case FZustand of
      rot        : begin FZustand := rotgelb;    setCounter(2);  end;
      rotgelb    : begin FZustand := gruen;      setCounter(10); end;
      gruen      : begin FZustand := dauergruen; setCounter(0);  end;
      dauergruen : { leer } ;
      gelb       : begin FZustand := rot;        setCounter(10); end;
    end
  else { eingabe = Taste }
    case FZustand of
      rot        : { leer } ;
      rotgelb    : { leer } ;
      gruen      : { leer } ;
      dauergruen : begin FZustand := gelb;       setCounter(2);  end;
      gelb       : { leer } ;
    end;
  if Assigned(OnChangeZustand) then OnChangeZustand;
end;

//-------- GetZustand (public) -----------------------------------------
function TAmpel.GetZustand : TZustand;
begin
  Result := FZustand;
end;

procedure TAmpel.SetCounter(t : word);
begin
  FCounter := t;
end;

procedure TAmpel.DecCounter;
begin
  if FCounter > 0
  then
  begin
    FCounter := FCounter - 1;
    if FCounter = 0 then switchZustand(OCN);
  end;
end;

function TAmpel.GetCounter : word ;
begin
  Result := FCounter;
end;

end.
