unit uAmpel5GUI; { mk, 11.5.03 , Fugngerampel 1 }
{$DEFINE DEBUG}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, mTAmpel5;

type
  TGUI = class(TForm)
    pAmpel: TPanel; shRot: TShape; shGelb: TShape; shGruen: TShape;
    pStange: TPanel; Timer1: TTimer;
    bTaste: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure bTasteClick(Sender: TObject);
  private
    {$IFDEF DEBUG}
    lCounter, lZustand : TLabel;
    {$ENDIF}
    Ampel : TAmpel;
    procedure updateView;
  public
    { Public-Deklarationen }
  end;

var
  GUI: TGUI;

implementation

{$R *.DFM}

procedure TGUI.FormCreate(Sender: TObject);
begin
  Ampel := TAmpel.Create;
  Ampel.OnChangeZustand := updateView;
  updateView;
  {$IFDEF DEBUG}
  lCounter := TLabel.Create(self); // hier: self = GUI
  lCounter.Parent := self; lCounter.top := 380; lCounter.Left := 90;
  lCounter.caption := '0';
  lZustand := TLabel.Create(self);
  lZustand.Parent := self; lZustand.top := 400; lZustand.Left := 90;
  lZustand.caption := 'dauergruen';
  {$ENDIF}
end;

procedure TGUI.FormDestroy(Sender: TObject);
begin
  Ampel.Free;
end;

procedure TGUI.updateView;
const
  clGreen = $0000FF00; // Hilfe zu TColor
begin
  case Ampel.GetZustand of
    rot        : begin
                   shRot.Brush.Color := clRed;
                   shGelb.Brush.Color := clBlack;
                   shGruen.Brush.Color := clBlack;
                   {$IFDEF DEBUG} lZustand.caption := 'rot'; {$ENDIF}
                 end;
    rotgelb    : begin
                   shRot.Brush.Color := clRed;
                   shGelb.Brush.Color := clYellow;
                   shGruen.Brush.Color := clBlack;
                   {$IFDEF DEBUG} lZustand.caption := 'rotgelb';
                   {$ENDIF}
                 end;
    dauergruen : begin
                   shRot.Brush.Color := clBlack;
                   shGelb.Brush.Color := clBlack;
                   shGruen.Brush.Color := clGreen;
                   {$IFDEF DEBUG} lZustand.caption := 'dauergruen'; {$ENDIF}
                 end;
    gruen      : begin
                   shRot.Brush.Color := clBlack;
                   shGelb.Brush.Color := clBlack;
                   shGruen.Brush.Color := clGreen;
                   {$IFDEF DEBUG} lZustand.caption := 'gruen'; {$ENDIF}
                 end;
    gelb       : begin
                   shRot.Brush.Color := clBlack;
                   shGelb.Brush.Color := clYellow;
                   shGruen.Brush.Color := clBlack;
                   {$IFDEF DEBUG} lZustand.caption := 'gelb'; {$ENDIF}
                 end;
  end;
end;

procedure TGUI.Timer1Timer(Sender: TObject);
begin
  Ampel.DecCounter;
  {$IFDEF DEBUG} lCounter.caption := IntToStr(Ampel.GetCounter); {$ENDIF}
end;

procedure TGUI.bTasteClick(Sender: TObject);
begin
  Ampel.switchZustand(Taste);
end;

end.

